﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    WinJS.Binding.optimizeBindingReferences = true;

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;
    var mainGrid;
    var myShape;

    var KEYCODE_LEFT = 37;
    var KEYCODE_RIGHT = 39;
    var KEYCODE_DOWN = 40;
    var KEYCODE_X = 88;

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: This application has been newly launched. Initialize
                // your application here.
            } else {
                // TODO: This application has been reactivated from suspension.
                // Restore application state here.
            }
            args.setPromise(WinJS.UI.processAll());

            document.addEventListener("keydown", OnKeyDown, false);
            mainGrid = document.getElementsByClassName("mainGrid")[0];
            myShape = new CSSTetris.ShapeZ(4);
            myShape.insertIntoGrid(mainGrid, 12, 20);
            init();
        }
    };

    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. You might use the
        // WinJS.Application.sessionState object, which is automatically
        // saved and restored across suspension. If you need to complete an
        // asynchronous operation before your application is suspended, call
        // args.setPromise().
    };

    function init() {
        setInterval(function () {
            myShape.moveDown();
        }, 1000);
    }

    function OnKeyDown(event) {
        switch (event.keyCode) {
            case KEYCODE_X:
                myShape.rotate();
                break;
            case KEYCODE_LEFT:
                myShape.moveLeft();
                break;
            case KEYCODE_RIGHT:
                myShape.moveRight();
                break;
            case KEYCODE_DOWN:
                myShape.moveDown();
                break;
        }
    }

    app.start();
})();
